<?php
/*	event
	name : イベント
	author: team1/3
	
*/

	global $params,$config;

	if (!isset($config)) { die(); }
	
	if (!defined("EVENT_ID")) {
		define ( "EVENT_ID", 163 );
	}

	draw();
	
	$params['rendering'] = false;

function draw()
{
	global $html,$params,$database,$ut;
	
	$page_ar = &$params['page'];
	$p_page = $page_ar['id'];
	
	if ($page_ar['mode'] == 10) {
		$html['article'][] = frame_renderer(view_page($page_ar));
		return;
	}
	
$html['css']['ctypedb-draw'] = <<<EOT
	<style>
	.onethird-ctypedb .table {
		display:table;
	}
	.onethird-ctypedb .left-unit {
		display:inline-block;
		min-width:100px;
		border: 1px solid #c0c0c0;
	}
	.onethird-ctypedb .mid-unit {
		display:table-cell;
		vertical-align: top;
		width:100%;
		padding:0 5px;
	}
	.onethird-ctypedb .image-panel {
		display:inline-block;
		width:300px;
		height:190px;
		overflow: hidden;
	}
	.onethird-ctypedb .image-panel img {
		width:100%;
	}
	.onethird-ctypedb .item-panel {
		position: relative;
		display:table;
		width: 100%;
	}
	.onethird-ctypedb .item-panel div.left {
		display:table-cell;
		min-width:150px;
		background-color: rgba(192, 192, 192, 0.85);
		padding:2px 5px;
		min-height:30px;
		border:1px solid #fff;
	}
	.onethird-ctypedb .item-panel div.right {
		display:table-cell;
		vertical-align: top;
		width:100%;
		padding:2px 5px;
		margin:0 2px;
		background-color: rgba(192, 192, 192, 0.5);
		border:1px solid #fff;
	}
	.onethird-ctypedb .top-unit , .onethird-ctypedb .bottom-unit{
		width:100%;
		margin: 5px 0;
	}
	.onethird-ctypedb .item {
		min-width:100px;
		display: inline-block;
		min-height:20px;
	}
	.onethird-ctypedb .item[data-type=img] {
		width:100%;
		min-height:150px;
	}
	.event-rem {
		font-weight:bold;
		font-size:150%;
	}
	</style>
EOT;

	if (isset($_GET['mode']) && $_GET['mode'] == 'edit') {
		// 編集
		provide_edit_module();
		unset($params['breadcrumb']);
		snippet_breadcrumb($p_page, 'Page Edit');
		$buff = page_edit_renderer($page_ar);
		$html['article'][] = frame_renderer($buff);
		return;

	} else if (isset($_GET['mode']) && $_GET['mode'] == 'export') {
		csv_export($page_ar);

	} else {
		// 通常表示
		snippet_breadcrumb($page_ar['link'], $page_ar['title']);

		$html['article'][] = frame_renderer(body_renderer($page_ar));	// 通常ページ部分

		if (isset($_GET['mode']) && $_GET['mode']=='contact_manager') {
			$html['article'][] = frame_renderer(contact_manager($page_ar));
		} else {
			$html['article'][] = contact_renderer($page_ar);
			$html['article'][] = innerpage_renderer($page_ar['id']);
		}
	}

	// css style
	if (!isset($html['head']['plugin-page-folder'])) {
$html['head']['plugin-page-folder'] = <<<EOT
		<style>
			.plugin-page-folder-unit {
				margin-bottom:10px;
			}
			.plugin-page-folder-unit p {
				margin:0 0 5px 0;
				padding:0;
			}
			.plugin-page-folder-unit .title {
				color: #286593;
				font-size: 20px;
				margin:0 0 5px 0;
			}
			.plugin-page-folder-unit .onethird-button {
				margin-top:10px;
			}
			.plugin-page-folder-unit .add-panel {
				margin:15px 0 15px 0;
			}
			.plugin-page-folder-unit img {
				vertical-align: middle;
			}
			.plugin-page-folder-unit p .date {
				color:#A0A0A0;
				font-size:90%;
			}
			.plugin-page-folder-unit p .new {
				color:#FF7000;
				padding:0 5px;
			}
		</style>
EOT;
	}
}

function csv_export(&$page_ar)
{
	global $database,$ut,$params,$p_circle,$config;
	if (!check_rights('edit'))  {
		exit();
	}
	
	$r = array();
	$r['result'] = false;
	$id = $page_ar['id'];
	$sql = array();

	$sql[0] = "select id,type,metadata,title,mode,user,date from ".DBX."data_items ";
	$sql[1] = array(" where type=? and block_type=10 and link=?",EVENT_ID,$page_ar['id']);
	$sql[2] = array(" order by date desc");
	$ar = $database->sql_select_all($sql);
	$buff = '';
	if ($ar) {
		$r['result'] = true;
		$column = array();
		foreach ($ar as $v) {
			$m = unserialize64($v['metadata']);
			if (!empty($m['plugin_embed'])) {
				foreach ($m['plugin_embed'] as $k=>$vv) {
					$column[$k] = 0;
				}
			}
		}
		$buff .= "date";
		foreach ($column as $k=>$v) {
			$k = str_replace(',','',$k);
			$buff .= ",$k";
		}
		$buff .= "\r\n";
		foreach ($ar as $v) {
			$m = unserialize64($v['metadata']);
			$ico = '';
			$u = $ut->link($v['id']);
			$d = substr($v['date'],0,10);
			$k = str_replace(',',' ',$k);
			$buff .= "$d";
			foreach ($column as $k=>$vv) {
				if (!empty($m['plugin_embed'][$k]) && $m['plugin_embed'][$k]) {
					$x = $m['plugin_embed'][$k];
					$x = str_replace(',',' ',$x);
					$buff .= ",$x";
				} else {
					$buff .= ",";
				}
			}
			$buff .= "\r\n";
		}
	}
	header("Content-Type: text/comma-separated-values");
	header("Content-Disposition: attachment; filename=\"{$page_ar['title']}.csv\"");
	echo $buff;
	exit();
}

function contact_renderer(&$page_ar)
{
	global $params, $ut, $html;
	$p_page = $page_ar['id'];

	if (check_rights('owner')) {
		set_func_right('edit.modules');
		set_func_right('add_page');
		provide_edit_rights();
		provide_edit_module();
	}
	

	if (empty($page_ar['meta']['flexedit']['contact_send_mess'][0]['text'])) {
$page_ar['meta']['flexedit']['contact_send_mess'][0]['text'] = <<<EOT
		<h2>正常に終了しました</h2>
		<p>
			申し込みありがとうございました
		</p>
		<p>
			確認メールを送信しましたのでご確認お願い致します
		</p>
		<p>
			※ キャンセル・人数変更方法は、確認メールに記載しています
		</p>
EOT;
		mod_data_items($page_ar);
	}
	if (check_rights('edit') && empty($page_ar['meta']['contact_form']['adr_page'])) {
$html['article'][] = <<<EOT
		<p style='background-color: #FFE2E2;padding: 20px;'>
			{$ut->icon('caution')} Mail address not set.
		</p>
EOT;
	}

	//送信処理
	if (isset($_POST['mdx']) && $_POST['mdx'] == 'send_contact_ex' && !empty($_POST['contents'])) {
		$page_ar['contents'] = '';
		if (!empty($page_ar['meta']['contact_form']['adr_page'])) {
	
			$mailadr = $page_ar['meta']['contact_form']['adr_page'];
			$mail_ar = array();
			
			$mail_ar['cc'] =  $mailadr;
			$mail_ar['from'] =  $mailadr;
			$mail_ar['user_nickname'] = 'message - post';
			$mail_ar['message'] = $_POST['contents'];
			$mail_ar['subject'] = "申込内容確認 - {$params['circle']['name']} ({$params['page']['id']}) ";
$mail_ar['message'] = <<<EOT

申し込みありがとうございます
以下の内容で受け付けました

{$_POST['contents']}

※ 申込内容を変更する場合は、同じお名前とメールアドレスで再登録してください

--
{$params['circle']['name']}
{$params['page']['title']}
POST URL {$ut->link($params['page']['id'])}


EOT;
			$mgx = !empty($page_ar['meta']['contact_form']['manager']);
			if ($mgx) {
				set_func_right('edit.modules');
				set_func_right('add_page',false);	//非ログイン状態でもページ追加を許可する
				provide_edit_rights();
			}
			$mail_ar['no-log'] = true;
			$rx = array();
			$rx['link'] = $page_ar['id'];
			$rx['result'] = false;
			$rx['type'] = EVENT_ID;
			$rx['mode'] = 10;
			$rx['title'] = 'EVENT-'.substr(time(),-4);
			$rx['block_type'] = 10;
			$dx = 0;
			foreach ($_POST as $k=>$v) {
				if (substr($k,0,5) == 'post_') {
					$k = mb_strtolower(sanitize_str(substr($k,5)));
					if (substr($k,0,5) == 'your_' || substr($k,0,5) == 'your ') {
						$k = substr($k,5);
					}
					if ($k == 'mail' || $k == 'mail address' || $k == 'メール' || $k == 'メールアドレス' ) {
						$rx['meta']['plugin_embed']['email'] = sanitize_str($v);
					} else if ($k == 'name' || $k == 'お名前' || $k == '名前') {
						$rx['meta']['plugin_embed']['name'] = sanitize_str($v);
					} else if ($k == '人数' || $k == 'member') {
						$rx['meta']['plugin_embed']['member_c'] = sanitize_str($v);
					} else {
						$rx['meta']['plugin_embed'][$k] = sanitize_str($v);
					}
					if ($k == '人数' || $k == 'member_c') {
						$dx = sanitize_num($v);
					}
				}
			}

			if (!empty($page_ar['meta']['contact_form']['p_max'])) {
				$count = get_contact_member_c( $page_ar );
				$p_max = $page_ar['meta']['contact_form']['p_max'];
				if ($p_max < $count+$dx) {
$buff = <<<EOT
					<h2>申し込みエラー</h2>
					<p>
						申し込み人数が多すぎるため登録できませんでした
					</p>
					<p>
						同伴者が多すぎるか、入力途中に他の方が申し込まれたためだと思われます
					</p>
					<p>
						再度、画面を更新してお試しください
					</p>
EOT;
					return $buff;
				}
			}

			$rx['meta']['post_contents'] = $_POST['contents'];
			$rx['meta']['template_ar']['php'] = ".".basename(__FILE__);
			unset($html['article']);
			$params['rendering'] = false;
			$mail_ar['to'] = false;
			if (!empty($rx['meta']['plugin_embed']['email'])) {
				$mail_ar['to'] = $rx['meta']['plugin_embed']['email'];
			}
			if ($mail_ar['to'] !== false && (!$mgx || create_page($rx))) {
				if (sx_send_mail($mail_ar)) {
					if (isset($page_ar['meta']['flexedit']['contact_send_mess'][0]['text'])) {
						$buff = $page_ar['meta']['flexedit']['contact_send_mess'][0]['text'];
						return $buff;
					}
				} else {
$buff = <<<EOT
					<h1>Mail send Error</h1>
					<p>
						Sorry, System Error has occurred.
					</p>
EOT;
					return $buff;
				}
			} else {
$buff = <<<EOT
				<h1>System Error</h1>
				<p>
					Sorry, System Error has occurred.
				</p>
				<p>
					Please try again from the beginning.
				</p>
EOT;
				return $buff;
			}
		}
	}

	// 通常表示
	return frame_renderer(write_contact($page_ar));
}

function get_contact_member_c( &$page_ar )
{
	global $params, $ut, $html, $database, $plugin_ar, $config;

	if (isset($page_ar['meta']['contact_form']['_count'])) {
		return $page_ar['meta']['contact_form']['_count'];
	}
	$sql = array();
	$sql[0] = "select id,type,metadata,title,mode,user,date from ".DBX."data_items ";
	$sql[1] = array(" where type=? and block_type=10 and link=?",EVENT_ID,$page_ar['id']);
	$ar = $database->sql_select_all($sql);
	$count = 0;
	if ($ar) {
		foreach ($ar as $v) {
			$m = unserialize64($v['metadata']);
			if (!empty($m['plugin_embed']['member_c'])) {
				$count += (int)$m['plugin_embed']['member_c'];

			} else if (!empty($m['plugin_embed']['人数'])) {
				$count += (int)$m['plugin_embed']['人数'];
			}
		}
	}
	return $page_ar['meta']['contact_form']['_count'] = $count;
}

function write_contact( &$page_ar )
{
	global $params, $ut, $html, $database, $plugin_ar, $config;

	$id = $page_ar['id'];

$html['css']['write_contact'] = <<<EOT
<style>
	#onethird-contactform .item {
		padding:10px;
		margin-bottom:5px;
		background-color: rgba(123, 122, 122, 0.12);
		position: relative;
	}
	#onethird-contactform .item input, #onethird-contactform .item textarea, #onethird-contactform .item select {
		border: 1px solid #CBCBCB;
	}
	#onethird-contactform .ok {
		background-color: #DEDEDE;
	}
	#onethird-contactform .ok input, #onethird-contactform .ok textarea {
		border: 1px solid #CBCBCB;
	}
	#onethird-contactform .ng {
		background-color: #FFD8D8;
	}
	#onethird-contactform .ng input, #onethird-contactform .ng textarea {
		border: 1px solid #F40;
	}
	#onethird-contactform .item .title {
		min-width:180px;
		display:inline-block;
		position: absolute;
		left: 0;
		padding-left:20px;
	}
	#onethird-contactform .item > div {
		margin-left:180px;
	}
	#onethird-contactform .must_alert {
		margin-left:180px;
		color: #F00;
	}
	@media (max-width: 768px) {
		#onethird-contactform .item .title {
			min-width:100%;
			display:block;
			position: relative;
			padding-left: 0;
			padding-bottom: 6px;
		}
		#onethird-contactform .item > div {
			margin-left:0;
			width:100%;
			display:block;
			position: relative;
			padding-left: 0;
		}
		#onethird-contactform .must_alert {
			margin-left:0;
			width:100%;
			display:block;
			position: relative;
			padding-left: 0;
		}
	}
	#onethird-contactform .item .contact_input {
		width:100%;
		padding:7px 10px;
		box-sizing: border-box;
		background-color:#fff;
		color:#000;
		font-size: 15px;
	}
	#onethird-contactform .item .contact_input:disabled {
		border:none;
	}
	#onethird-contactform .item .contact_input[type=radio]
	, #onethird-contactform .item .contact_input[type=checkbox] {
		width:2em;
	}
	#onethird-contactform .must {
		background-color: rgba(255, 73, 3, 0.18);
	}
	#onethird-contactform .must.ok {
		background-color: #DEDEDE;
	}
	#onethird-contactform .must .title:after {
		content: '*';
		position: absolute;
		right: 20px;
		top: 0;
		color: #F00;
		font-size:20px;
	}
	#onethird-contactform .ok .title:after {
		content: '';
		background-image: url({$config['site_url']}img/ok.png);
		position: absolute;
		right: 20px;
		top: 5px;
		height: 16px;
		width: 16px;
	}
	#_tryitEditor_contents #onethird-contactform .item {
		border:1px dotted #CB0F00;
	}
	#contact_toolbar select:disabled,#contact_toolbar .disabled {
		opacity:0.5;
		cursor: not-allowed;
	}
	#_tryitEditor_contents #onethird-contactform .sel_item {
		border:1px solid #CB0F00;
		background-color: rgba(123, 122, 122, 0.30);
	}
	#_tryitEditor_contents #onethird-contactform .checkbox_add
	, #_tryitEditor_contents #onethird-contactform .checkbox_del {
		display: inline-block;
		margin-left: 10px;
		cursor: pointer;
		width:20px;
		height:20px;
		vertical-align: middle;
	}
	#_tryitEditor_contents #onethird-contactform .checkbox_add {
		background-image:url({$config['site_url']}img/add.png);
		background-size: 18px;
	}
	#_tryitEditor_contents #onethird-contactform .checkbox_del {
		background-image:url({$config['site_url']}img/remove.png);
		background-size: 18px;
	}
	
</style>
EOT;

	if (check_rights('edit')) {
$html['js']['write_contact'] = <<<EOT
<script>
	\$(function(){
		ot.set_contact_option = function() {
			ot.tryitEditor.opt.hide_ind = true;
			ot.tryitEditor.opt.after_toolbar += "<br /> ";
			ot.tryitEditor.opt.after_toolbar += "<div id='contact_toolbar'>";
			ot.tryitEditor.opt.after_toolbar += "<select id='contact_item'><option value=''>--</option><option value='text'>text</option><option value='radio'>radio</option><option value='checkbox'>checkbox</option><option value='textarea'>textarea</option><option value='tel'>tel</option><option value='email'>email</option><option value='number'>number</option><option value='select'>select</option></select>";
			ot.tryitEditor.opt.after_toolbar += " <a href='javascript:void(ot.inpage_write_contact_move(-1))'  title='move up' class='onethird-button mini' >{$ut->icon('up')}</a>";
			ot.tryitEditor.opt.after_toolbar += " <a href='javascript:void(ot.inpage_write_contact_move(1))' title='move down' class='onethird-button mini' >{$ut->icon('dn')}</a>";
			ot.tryitEditor.opt.after_toolbar += " <a href='javascript:void(ot.inpage_write_contact_copy())' title='copy' class='onethird-button mini' >copy</a>";
			ot.tryitEditor.opt.after_toolbar += " <a href='javascript:void(ot.inpage_write_contact_del())' title='remove' class='onethird-button mini' >remove</a>";
			ot.tryitEditor.opt.after_toolbar += "<label><input type='checkbox' id='contact_must' onclick='ot.adj_contact_must(\"toggle\")' />must<label>";
			ot.tryitEditor.opt.after_toolbar += "</div>";

			ot.tryitEditor.opt.onready = function() {
				\$('#contact_toolbar a,#contact_toolbar input').prop('disable',true);
				ot.adj_contact_toolbar(false);
				ot.adj_contact_hnd();
				\$('#_tryitEditor_contents').click(function(e){
					if (e.target) {
						var o = e.target;
						if (o.tagName == 'LABEL') {
							\$(o).parent().find('.checkbox_txt').val(o.innerText);
							return;
						}
						ot._contact_obj = false;
						\$('#_tryitEditor_contents .item').removeClass('sel_item');
						while (o.parentNode) {
							var x = \$(o);
							if (x.hasClass('item')) {
								ot._contact_obj = o;
								var val = '';
								if (x.find('div .contact_input[type=text]').length) {
									val = 'text';
								} else if (x.find('div .contact_input[type=email]').length) {
									val = 'email';
								} else if (x.find('div .contact_input[type=tel]').length) {
									val = 'tel';
								} else if (x.find('div .contact_input[type=number]').length) {
									val = 'number';
								} else if (x.find('div .contact_input[type=checkbox]').length) {
									val = 'checkbox';
								} else if (x.find('div .contact_input[type=radio]').length) {
									val = 'radio';
								} else if (x.find('div textarea.contact_input').length) {
									val = 'textarea';
								} else if (x.find('div select.contact_input').length) {
									val = 'select';
								}
								if (\$('#contact_item').val() != val) {
									\$('#contact_item').val(val);
								}
								break;
							}
							o = o.parentNode;
						}
						ot.adj_contact_toolbar(ot._contact_obj);
					}
				});
				\$('#contact_item').change(function(e){
					var o = \$(this);
					var x = \$(ot._contact_obj).find('div');
					x.html('');
					if (o.val() == 'text') {
						x.append("<input type='text' class='contact_input' />");
					} else if (o.val() == 'mail') {
						x.append("<input type='mail' class='contact_input' />");
					} else if (o.val() == 'tel') {
						x.append("<input type='tel' class='contact_input' />");
					} else if (o.val() == 'number') {
						x.append("<input type='number' class='contact_input' />");
					} else if (o.val() == 'textarea') {
						x.append("<textarea class='contact_input'></textarea>");
					} else if (o.val() == 'select') {
						x.append("<select class='contact_input'><option value=''>---</option></select>");
						ot.adj_contact_hnd();
					} else if (o.val() == 'checkbox') {
						x.append("<label><input type='checkbox' class='contact_input' />checkbox</label>");
						ot.adj_contact_hnd();
					} else if (o.val() == 'radio') {
						var a = new Date();
						x.append("<label><input type='radio' class='contact_input' name='contact_"+a.getTime()+"' />radio</label>");
						ot.adj_contact_hnd();
					}
				});
				\$(document).on('click','#_tryitEditor_contents #onethird-contactform .checkbox_add',function(){
					var o = \$(this);
					var z = o.prev();
					var x = z.prev();
					if (x.prop('tagName') == 'LABEL') {
						var y = x.find('input');
						var h = '';
						z = z.val();
						if (!z) { z = 'option'; }
						if (y.prop('type') == 'radio') {
							h = "<label><input type='radio' class='contact_input' name='"+y.prop('name')+"' />"+z+"</label>";
						} else {
							h = "<label><input type='checkbox' class='contact_input' />"+z+"</label>";
						}
						x.after(h);
					} else {
						var x = o.parents('.item');
						y = x.find('select');
						z = x.find('input[type=text]');
						if (y.length==1 && z.length==1) {
							y.append("<option value='"+z.val()+"'>"+z.val()+"</option>");
							y.val(z.val());
						}
					}
				});
				\$(document).on('click','#_tryitEditor_contents #onethird-contactform .checkbox_del',function(){
					var o = \$(this);
					var x = o.parents('.item');
					if (x.length) {
						var y = x.find('input:checked').parent('label');
						if (y.length==1) {
							y.remove();
						} else {
							y = x.find('option:selected')
							if (y.length==1) {
								y.remove();
							}
						}
					}
				});
				\$(document).on('change','#_tryitEditor_contents #onethird-contactform select',function(){
					var o = \$(this);
					var z = o.parent().find('.checkbox_txt');
					if (z.length) {
						z.val(o.val());
					}
				});
				\$(document).on('keyup','#_tryitEditor_contents #onethird-contactform .checkbox_txt',function(){
					var o = \$(this);
					var x = o.parents('.item');
					if (x.length) {
						var y = x.find('input:checked').parent('label');
						if (y.length==1) {
							y = y[0];
							y.innerHTML = y.firstChild.outerHTML + o.val();
							y.firstChild.checked=true;
						} else {
							y = x.find('option:selected')
							if (y.length==1 && y.val()) {
								y.text(o.val()).val(o.val());
							}
						}
					}
				});
				if (!ot.tryitEditor.org_html) {
					ot.tryitEditor.org_html = ot.tryitEditor.html;
					ot.tryitEditor.html = function(a) {
						ot.adj_contact_toolbar(false);
						\$("#_tryitEditor_contents #onethird-contactform .checkbox_add").remove();
						\$("#_tryitEditor_contents #onethird-contactform .checkbox_del").remove();
						\$("#_tryitEditor_contents #onethird-contactform .checkbox_txt").remove();
						\$("#_tryitEditor_contents #onethird-contactform input").prop('readonly',false);
						\$("#_tryitEditor_contents #onethird-contactform input").each(function(){
							var o = \$(this);
							try {
								var t = o.parents('.item').find('.title').text().trim();
								if (t) {
									o.prop('name',t);
									ar[t] = true;
								}
							} catch (e) {
							}
						});
						return ot.tryitEditor.org_html(a);
					}
				}
			}
		};
		ot.inpage_write_contact_move = function(dx){
			if (!ot._contact_obj) { return; }
			if (ot.tryitEditor.ie9over) { document.execCommand("ms-beginUndoUnit"); }
			var o = ot._contact_obj;
			var obj = \$(o);
			if (dx == -1 && o.previousElementSibling) {
				\$(o.previousElementSibling).before(o);
			}
			if (dx == 1 && o.nextElementSibling) {
				\$(o.nextElementSibling).after(o);
			}
			if (ot.tryitEditor.ie9over) { document.execCommand("ms-endUndoUnit"); }
		};
		ot.inpage_write_contact_copy = function(){
			if (!ot._contact_obj) { return; }
			if (ot.tryitEditor.ie9over) { document.execCommand("ms-beginUndoUnit"); }
			var o = ot._contact_obj;
			\$(o).after(o.outerHTML.toString());
			\$('#_tryitEditor_contents .item').removeClass('sel_item');
			\$(o).addClass('sel_item');
			if (ot.tryitEditor.ie9over) { document.execCommand("ms-endUndoUnit"); }
		};
		ot.inpage_write_contact_del = function(){
			if (!ot._contact_obj) { return; }
			if (ot.tryitEditor.ie9over) { document.execCommand("ms-beginUndoUnit"); }
			var o = ot._contact_obj;
			\$(o).remove();
			ot.adj_contact_toolbar(ot._contact_obj = false);
			if (ot.tryitEditor.ie9over) { document.execCommand("ms-endUndoUnit"); }
		};
		ot.adj_contact_toolbar = function(a){
			if (a) {
				\$('#contact_toolbar select,#contact_toolbar input').prop('disabled',false);
				\$('#contact_toolbar a,#contact_toolbar label').removeClass('disabled');
				\$(a).addClass('sel_item');
			} else {
				\$('#contact_item').val('');
				\$('#contact_toolbar select,#contact_toolbar input').prop('disabled',true);
				\$('#contact_toolbar a,#contact_toolbar label').addClass('disabled');
				\$('#_tryitEditor_contents .item').removeClass('sel_item');
			}
			ot.adj_contact_must();
		};
		ot.adj_contact_must = function(a){
			if (!ot._contact_obj) { return; }
			if (a == 'toggle') {
				\$(ot._contact_obj).toggleClass('must');
			} else {
				if (\$(ot._contact_obj).hasClass('must')) {
					\$("#contact_must").prop('checked',true)
				} else {
					\$("#contact_must").prop('checked',false)
				}
			}
		};
		ot.adj_contact_hnd = function(){
			\$("#_tryitEditor_contents #onethird-contactform .checkbox_add").remove();
			\$("#_tryitEditor_contents #onethird-contactform .checkbox_del").remove();
			\$("#_tryitEditor_contents #onethird-contactform .checkbox_txt").remove();
			\$("#_tryitEditor_contents #onethird-contactform label:last-child").after(" <input type='text' style='margin:2px 2px 0 0;width:80px;' class='checkbox_txt' /><span class='checkbox_add'></span><span class='checkbox_del'></span>");
			\$("#_tryitEditor_contents #onethird-contactform select").attr("contenteditable","false").after(" <input type='text' style='margin:2px 2px 0 0' class='checkbox_txt' /><span class='checkbox_add'></span><span class='checkbox_del'></span>");
		};
	});
</script>
EOT;
	}
	if (!check_rights()) {
		provide_onethird_object();
	}
$html['js']['write_contact_guest'] = <<<EOT
<script>
	\$(function(){
		ot.contact_next = function() {
			\$("#form_contact_ex #contents").val('');
			\$('#onethird-contactform .must_alert').remove();
			\$("#form_contact_ex .send_data").remove();
			\$('#onethird-contactform .ng').removeClass('ng');
			\$('#onethird-contactform .contact_input').each(function(){
				var obj = \$(this);
				var tag = this.tagName;
				var type = this.type;
				var o = obj.parents('.item');
				var label = '';
				if (type=='radio' || type=='checkbox') {
					if (o.hasClass('ok')) {
						if (this.checked) {
							label = obj.parents('label').text();
							var x = \$("#form_contact_ex #contents");
							x.val(x.val() + "\\n["+o.find('.title').text()+"]\\n" + obj.parents('label').text() + "\\n");
							\$("#form_contact_ex ").append(\$("<input type='hidden' class='send_data' />").val('YES').attr('name','post_'+label));
						}
						return;
					}
					if (!this.checked) {
						if (o.find('.contact_input:checked').length) {
							o.addClass('ok').removeClass('ng');
							o.find('.must_alert').remove();
							return;
						}
					}
				} else {
					label = o.children('.title').text();
				}
				var ok_one = false;
				var x = \$("#form_contact_ex #contents");
				if (o.hasClass('item')) {
					if (type=='radio' || type=='checkbox' || !obj.val()) {
						if (o.hasClass('must')) {
							if (!o.hasClass('ng')) {
								o.addClass('ng');
								o.append("<p class='must_alert'>- 必須</p>");
							}
						} else {
							ok_one = true;
						}
					} else {
						ok_one = true;
						var v = obj.val();
						x.val(x.val() + "\\n["+label+"]\\n" + v + "\\n");
						\$("#form_contact_ex ").append(\$("<input type='hidden' class='send_data' />").val(v).attr('name','post_'+label));
					}
				}
				if (ok_one) {
					o.addClass('ok').removeClass('ng');
				}
			});
			if (!\$('#onethird-contactform .item.ng').length) {
				\$('#onethird-contactform .contact_input').prop("disabled", true);
				\$('#contact_back').show();
				\$('#contact_send').show();
				\$('#contact_next').hide();
			}
		};
		ot.contact_back = function() {
			\$('#onethird-contactform .contact_input').removeAttr('disabled');
			\$('#contact_back').hide();
			\$('#contact_send').hide();
			\$('#contact_next').show();
		};
		ot.contact_send = function() {
			if (confirm('メールアドレスに間違いがないことを確認してください \\n送信しますか？')) {
				\$('#form_contact_ex').append("<input type='hidden' name='xtoken' value='"+ot.magic_str+"' />");
				\$('#form_contact_ex').submit();
			}
		};
	});
</script>
EOT;

	//旧版との互換
	if ($params['page']['id'] != $page_ar['id'] && isset($params['page']['meta']['flexedit']['contact'][0]['text'])) {
		$page_ar['meta']['flexedit']['contact'][0]['text'] = $params['page']['meta']['flexedit']['contact'][0]['text'];
		unset($params['page']['meta']['flexedit']['contact'][0]['text']);
		$params['page']['metadata'] = serialize64($params['page']['meta']);
		mod_data_items($params['page']);
		mod_data_items($page_ar);
	}

	$buff = '';
	
	$ap = true;
	if (!empty($page_ar['meta']['contact_form']['p_mode'])) {
		$ap = false;
		if ($page_ar['meta']['contact_form']['p_mode'] == 1) {
$buff .= <<<EOT
			<p>現在、募集中止しています</p>
EOT;
		}
	}
	if ($ap && !empty($page_ar['meta']['contact_form']['p_max'])) {
		$count = get_contact_member_c( $page_ar );
		$p_max = $page_ar['meta']['contact_form']['p_max'];
		if ($p_max <= $count) {
			if (empty($page_ar['meta']['contact_form']['p_waiting'])) {
				$ap = false;
$buff .= <<<EOT
				<p class='event-rem'>申し込みは締め切りました</p>
				<p>
					申し訳ありませんが、定員のため募集終了しました
				</p>
EOT;
			} else {
$buff .= <<<EOT
				<p class='event-rem'>現在、定員のためキャンセル待ちとなっています</p>
				<p>
					以下のフォームでキャンセル待ち予約が行えます
				</p>
EOT;
			}
		} else {
			$d = $p_max - $count;
			$buff .= "<p style='font-size:200%'>残席 {$d} です</p>";
		}
	}

	//コンタクトフォーム部分
	if (check_rights('edit') && !isset($page_ar['meta']['flexedit']['contact'][0]['text'])) {
		//データがないので初期化
$tmp = <<<EOT
		<div id='onethird-contactform'>
			<div class='item must'>
				<span class='title'>お名前</span>
				<div><input type="text" class='contact_input'  /></div>
			</div>
			<div class='item must'>
				<span class='title'>メールアドレス</span>
				<div>
					<input type="email" class='contact_input'  />
				</div>
				<p>
				※ 携帯メールアドレスはご利用いただけません
				</p>
			</div>
			<div class='item must'>
				<span class='title '>電話番号</span>
				<div><input type="tel" class='contact_input' /></div>
			</div>
			<div class='item'>
				<span class='title '>人数</span>
				<div>
					<select class='contact_input'>
						<option>1</option>
						<option>2</option>
						<option>3</option>
						<option>4</option>
						<option>5</option>
						<option>6</option>
						<option>7</option>
						<option>8</option>
						<option>9</option>
					</select>
				</div>
			</div>
			<div class='item'>
				<span class='title '>同伴参加者</span>
				<div>
					<textarea class="contact_input"></textarea>
					<ul>
					<li>参加者の重複を防ぐため本人以外のお連れ様をお書きください</li>
					<li>お一人で参加される方は空欄にしてください</li>
					</ul>
				</div>
			</div>
		</div>
EOT;
		$page_ar['meta']['flexedit']['contact'][0]['text'] = $tmp;
		$params['flexedit'][$page_ar['id']]['id'] = $page_ar['id'];
		$params['flexedit'][$page_ar['id']]['data']['contact'][0]['text'] = $tmp;
		mod_data_items($page_ar);
	}
	
	//表示
	if ($ap) {
		$buff .= edit_proc(array('page'=>$page_ar['id'],'name'=>'contact','mode'=>'inline','no-edit'=>'true'));
	} else {
	}

	//オプション
	if (check_rights('owner')) {
$buff .= <<<EOT
		<div class='edit_pointer'>
EOT;
			//$buff .= std_blockmenu_renderer($page_ar);
			if (!empty($page_ar['meta']['contact_form']['manager'])) {
$buff .= <<<EOT
				<a href='{$ut->link($page_ar['id'],'&:mode=contact_manager')}' class='onethird-button mini'>Manager</a>
EOT;
			}
$buff .= <<<EOT
			<a href='javascript:void(ot.inpage_edit({"page":{$page_ar['id']}, "name":"contact_send_mess", "idx":"0"}))' class='onethird-button mini'>Sent message</a>
			<a href='javascript:void(ot.contact_form_setting())' class='onethird-blockmenu'>{$ut->icon('setting')}</a>
			<span onclick="ot.inpage_edit({'page':{$page_ar['id']},'mode':this,'name':'contact' ,'idx':'0','onedit':function(){ot.set_contact_option()} })">{$ut->icon('edit',' class="onethird-blockmenu" ')}</span>
		</div>
EOT;
	} else if (check_rights('edit') && !empty($page_ar['meta']['contact_form']['manager'])) {
$buff .= <<<EOT
		<div class='edit_pointer'>
			<a href='{$ut->link($page_ar['id'],'&:mode=contact_manager')}' class='onethird-button mini'>Manager</a>
		</div>
EOT;
	}
	if (check_rights('owner')) {
		snippet_std_setting('Contact form setting','contact_form_setting');
		if (isset($_POST['ajax']) && $_POST['ajax'] == 'contact_form_setting')  {
			$r = array();
			$r['result'] = true;
			$p_adr = '';
			if (isset($page_ar['meta']['contact_form']['adr_page'])) {
				$p_adr = $page_ar['meta']['contact_form']['adr_page'];
			}
$r['html'] = <<<EOT
			<table>
				<tr>
					<td>Destination mail address</td>
					<td><input type='text' data-input='p_adr' value='{$p_adr}' />
				</tr>
				<tr>
					<td>Option</td>
					<td><label><input type='checkbox' data-input='p_manager' {$ut->check(!empty($page_ar['meta']['contact_form']['manager']),' checked ')}  />Use Manager</label>
				</tr>
			</table>
EOT;
			echo(json_encode($r));
			exit();
		}
		 
		if (isset($_POST['ajax']) && $_POST['ajax'] == 'save_contact_form_setting')  {
			$r = array();
			if (!isset($page_ar['meta']['contact_form'])) {
				$page_ar['meta']['contact_form'] = array();
			}
			$page_ar['meta']['contact_form']['adr_page'] = sanitize_str($_POST['p_adr']);
			if (!empty($_POST['p_manager']) && $_POST['p_manager'] == 'true') {
				$page_ar['meta']['contact_form']['manager'] = true;
			} else {
				$page_ar['meta']['contact_form']['manager'] = '';
			}
			$r['result'] = mod_data_items($page_ar);
			echo(json_encode($r));
			exit();
		}
	}

	if ($ap) {
$buff .= <<<EOT
		<form id='form_contact_ex' method='post' action='{$_SERVER['REQUEST_URI']}'>
			<input type='hidden' name='mdx' value='send_contact_ex' />
			<textarea name='contents' id='contents' style='display:none' />
			</textarea>
			<div class='action-panel'>
				<input type='button' id='contact_back' onclick='ot.contact_back()' style='display:none' class="onethird-button" value='Back' />
				<input type='button' id='contact_next' onclick='ot.contact_next()' class="onethird-button default" value='次へ &raquo;' />
				<input type='button' id='contact_send' onclick='ot.contact_send()' style='display:none' class="onethird-button default" value='送信する &raquo;' />
			</div>
		</form>
EOT;
	}
	return $buff;
}


function contact_manager(&$page_ar)
{
	global $params, $ut, $html, $database;

	$params['rendering'] = false;
	$p_page = $page_ar['id'];
	
	unset($html['article']);

	if (check_rights('owner')) {
		snippet_std_setting('Contact form setting','contact_form_setting');
		if (isset($_POST['ajax']) && $_POST['ajax'] == 'contact_form_setting')  {
			$r = array();
			$r['result'] = true;
			$p_max = 0;
			if (!empty($page_ar['meta']['contact_form']['p_max'])) {
				$p_max = $page_ar['meta']['contact_form']['p_max'];
			}
			$p_waiting = 0;
			if (!empty($page_ar['meta']['contact_form']['p_waiting'])) {
				$p_waiting = $page_ar['meta']['contact_form']['p_waiting'];
			}
			$p_mode = 0;
			if (!empty($page_ar['meta']['contact_form']['p_mode'])) {
				$p_mode = $page_ar['meta']['contact_form']['p_mode'];
			}
$r['html'] = <<<EOT
			<table>
				<tr>
					<td>定員数</td>
					<td><input type='text' data-input='p_max' value='{$p_max}' />
				</tr>
				<tr>
					<td>キャンセル待ち</td>
					<td>
						<li><label>
							<input type='checkbox' data-input='p_waiting' 
								{$ut->check(!empty($page_ar['meta']['contact_form']['p_waiting']),'checked')}/> 
								自動処理
							</label>
						</li>
					</td>
				</tr>
				<tr>
					<td>Status</td>
					<td>
						{$ut->input(
							array('type'=>'select'
								, 'data-input'=>'p_mode'
								, 'value'=>$p_mode
								, 'option'=>array('0'=>'募集中','1'=>'募集停止','3'=>'非表示')
							)
						)}
					</td>
				</tr>
			</table>
EOT;
			echo(json_encode($r));
			exit();
		}
		 
		if (isset($_POST['ajax']) && $_POST['ajax'] == 'save_contact_form_setting')  {
			$r = array();
			if (!isset($page_ar['meta']['contact_form'])) {
				$page_ar['meta']['contact_form'] = array();
			}
			$page_ar['meta']['contact_form']['p_max'] = sanitize_num($_POST['p_max']);
			$page_ar['meta']['contact_form']['p_mode'] = sanitize_num($_POST['p_mode']);
			$page_ar['meta']['contact_form']['p_waiting'] = (isset($_POST['p_waiting'])) ? 1:0;
			$r['result'] = mod_data_items($page_ar);
			echo(json_encode($r));
			exit();
		}
		if (isset($_POST['ajax']) && $_POST['ajax'] == 'add_m_page') {
			$rx = array();
			$rx['link'] = $page_ar['id'];
			$rx['result'] = false;
			$rx['type'] = EVENT_ID;
			$rx['mode'] = 10;
			$rx['title'] = 'EVENT-'.substr(time(),-4);
			$rx['block_type'] = 10;
			$dx = 0;
			$rx['meta']['plugin_embed']['name'] = (isset($_POST['p_name']))?sanitize_str($_POST['p_name']):'';
			$rx['meta']['plugin_embed']['member_c'] = (isset($_POST['p_num']))?sanitize_str($_POST['p_num']):'1';
			$rx['meta']['template_ar']['php'] = ".".basename(__FILE__);
			$rx['result'] = create_page($rx);
			echo(json_encode($rx));
			exit();
		}
$html['meta']['contact_manager'] = <<<EOT
		<script>
		\$(function(){
			ot.add_m_page = function() {
				var p_name = \$('.add_m_page #p_name').val();
				var p_num = \$('.add_m_page #p_num').val();
				ot.ajax({
					type: "POST"
					, url: '{$_SERVER['REQUEST_URI']}'
					, data: "ajax=add_m_page&p_name="+encodeURIComponent(p_name)+"&p_num="+encodeURIComponent(p_num)
					, dataType:'json'
					, success: function(data){
						if (data['result']) {
							location.reload(true);
						} else {
							alert('Input error');
						}
					}
				});
			}
			ot.add_m_page_op_cl = function(obj) {
				\$(obj).hide().next().fadeIn();
			}
		});
		</script>
EOT;
	}

	$buff = '';
$buff .= <<<EOT
	<h1>Event manager</h1>
EOT;

	$c = get_contact_member_c( $page_ar );
$buff .= <<<EOT
	<p>
		参加者{$c}名です
	</p>
	<div class='edit_pointer'>
		<a href='{$ut->link($page_ar['id'],'&:mode=export')}' class='onethird-button mini'>CSV export</a>
		<a href='javascript:void(ot.contact_form_setting())' >{$ut->icon('setting')}</a>
	</div>
EOT;

	$sql = array();
	$sql[0] = "select id,type,metadata,title,mode,user,date from ".DBX."data_items ";
	$sql[1] = array(" where type=? and block_type=10 and link=?",EVENT_ID,$page_ar['id']);
	$sql[2] = array(" order by date desc");
	$ar = $database->sql_select_all($sql);

	if ($ar) {
		//メタデータからカラム作成/データ整形
		$column = array();
		foreach ($ar as &$v) {
			$v['meta'] = unserialize64($v['metadata']);
			unset($v['metadata']);
			if (empty($v['meta']['plugin_embed'])) { $v['meta']['plugin_embed'] = array(); }
			if (isset($v['meta']['plugin_embed']['note'])) {
				continue;	//noteは一番後ろ
			}
			if (isset($v['meta']['plugin_embed']['member_c'])) {
				$v['meta']['plugin_embed']['人数'] = $v['meta']['plugin_embed']['member_c'];
				unset($v['meta']['plugin_embed']['member_c']);
			}
			if (isset($v['meta']['plugin_embed']['お名前'])) {
				$v['meta']['plugin_embed']['name'] = $v['meta']['plugin_embed']['お名前'];
				unset($v['meta']['plugin_embed']['お名前']);
			}
			foreach ($v['meta']['plugin_embed'] as $k=>$vv) {
				$column[$k] = 0;
			}
		}
		$column['note'] = 0;
		unset($v);
		//メール一覧作成
		$mail_ar = array();
		foreach ($ar as $v) {
			$m = $v['meta'];
			foreach ($v['meta']['plugin_embed'] as $k=>$vv) {
				if ($k == 'email') {
					if (empty($mail_ar[$vv])) {$mail_ar[$vv]=0;}
					++$mail_ar[$vv];
				}
			}
		}
$buff .= <<<EOT
		<table class='onethird-table'>
			<tr>
				<th>date</th>
EOT;
				foreach ($column as $k=>$v) {
$buff .= <<<EOT
					<th>$k</th>
EOT;
				}
$buff .= <<<EOT
				<th></th>
			</tr>
EOT;
			foreach ($ar as $v) {
				$m = $v['meta'];
				$ico = '';
				$u = $ut->link($v['id']);
				if ($v['type'] == PAGE_FOLDER_ID) { $ico = $ut->icon('folder',"width='16'"); }
				$d = substr($v['date'],0,10);
$buff .= <<<EOT
				<tr>
					<td><a href='{$ut->link($v['id'])}'>$d</a></td>
EOT;
					foreach ($column as $k=>$vv) {
						if (!empty($m['plugin_embed'][$k]) && $m['plugin_embed'][$k]) {
							$m['plugin_embed'][$k] = adjust_mstring($m['plugin_embed'][$k],30);
$buff .= <<<EOT
							<td>{$m['plugin_embed'][$k]}</td>
EOT;
						} else {
$buff .= <<<EOT
							<td></td>
EOT;
						}
					}
$buff .= <<<EOT
					<td>
EOT;
						if (!empty($m['plugin_embed']['email']) && isset($mail_ar[$m['plugin_embed']['email']]) && (int)$mail_ar[$m['plugin_embed']['email']] > 1) {
$buff .= <<<EOT
							<span style='color:red;font-weight:bold;'>重複</span>
EOT;
						}
$buff .= <<<EOT
					</td>
				</tr>
EOT;
			}
$buff .= <<<EOT
		</table>
		<div class='onethird-setting onethird-panel add_m_page' style='display: inline-block;'>
			<div onclick='ot.add_m_page_op_cl(this)' style='cursor:pointer'>追加</div>
			<table style='display:none'>
				<tr>
					<td>名前</td> <td><input type='text' value='' id='p_name' /></td>
				</tr>
				<tr>
					<td>人数</td> <td><input type='number' value='1' id='p_num' />
					</td>
				</tr>
				<tr>
					<td></td> <td>
						<input type='button' value='add' class='onethird-button mini' onclick='ot.add_m_page()' />
					</td>
				</tr>
			</table>
		</div>
EOT;
	}

	return $buff;
}

function view_page(&$page_ar)
{
	global $html,$params,$database,$config,$ut;

	$p_page = $page_ar['id'];

$html['css']['contact_page'] = <<<EOT
	<style>
		.contact_post {
			font-family:'Open Sans','Helvetica Neue',Helvetica,Meiryo,Arial,sans-serif;
			padding: 10px 20px;
			background-color: rgba(192, 192, 192, 0.18);
		}
	</style>
EOT;

	if (isset($_GET['mode']) && $_GET['mode']=='edit') {
		set_func_right('page_property');
		provide_edit_module();
		snippet_page_property();
		snippet_breadcrumb($p_page, 'Page Edit');
		$buff = page_edit_renderer($params['page']);
		return frame_renderer($buff);
	}

	$buff ='';
	if (check_rights('edit')) {
		unset($params['breadcrumb']);
		$params['breadcrumb'][] = array( 'link'=>'', 'text'=>"<a href='{$ut->link($params['page']['link'],'&:mode=contact_manager')}'>Manager</a>" );
		$params['breadcrumb'][] = array( 'link'=>'', 'text'=>"View data" );
		$page_ar['title'] = '';
		if (!empty($page_ar['meta']['post_contents'])) {
			$buff .= frame_renderer("<pre class='contact_post'>".$page_ar['meta']['post_contents']."</pre>");
		}
		$buff .= frame_renderer(body_renderer($page_ar));
		$buff .= innerpage_renderer($page_ar['id']);
	} else {
		snippet_breadcrumb($page_ar['link'], "error");
		//ページは表示しない
	}
	
	$plugin = 'plugin_proc';
$buff .= <<<EOT
	<div class='onethird-setting onethird-panel'>
		<table>
			<tr>
				<td>name</td>
				<td>
					{$plugin('embed','text','page:self','name:name')}
				</td>
			</tr>
			<tr>
				<td>人数</td>
				<td>
					{$plugin('embed','number','page:self','name:member_c')}
				</td>
			</tr>
			<tr>
				<td>note</td>
				<td>
					{$plugin('embed','edit','page:self','name:note')}
				</td>
			</tr>
		</table>
	</div>
EOT;
	return $buff;
}


?>